
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

void Nokia_initlcd(void);                    
void Nokia_writecom(char);                
void Nokia_write_data(char);                
void Nokia_write_reg(char,char);
void Nokia_clockdata(char);                
void Nokia_clearram(void);                
void Nokia_cursorxy(char,char);            
void Nokia_putchar(char);                    

void Nokia_putstrf(char flash *);            
void Nokia_putstr(char  *);

void Nokia_putnum_megafont(char ch, char char_start, char y);

flash static const char font5x7[256][5] = {
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x06, 0x84, 0xFE, 0x84, 0x06},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x7F, 0x3E, 0x1C, 0x08},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x3E, 0x51, 0x49, 0x45, 0x3E},
{0x00, 0x42, 0x7F, 0x40, 0x00},
{0x42, 0x61, 0x51, 0x49, 0x46},
{0x21, 0x41, 0x45, 0x4B, 0x31},
{0x18, 0x14, 0x12, 0x7F, 0x10},
{0x27, 0x45, 0x45, 0x45, 0x39},
{0x3C, 0x4A, 0x49, 0x49, 0x30},
{0x01, 0x71, 0x09, 0x05, 0x03},
{0x36, 0x49, 0x49, 0x49, 0x36},
{0x06, 0x49, 0x49, 0x29, 0x1E},
{0x00, 0x36, 0x36, 0x00, 0x00},
{0x00, 0x56, 0x36, 0x00, 0x00},
{0x08, 0x14, 0x22, 0x41, 0x00},
{0x14, 0x14, 0x14, 0x14, 0x14},
{0x00, 0x41, 0x22, 0x14, 0x08},
{0x02, 0x01, 0x51, 0x09, 0x06},
{0x32, 0x49, 0x79, 0x41, 0x3E},
{0x7E, 0x11, 0x11, 0x11, 0x7E},
{0x7F, 0x49, 0x49, 0x49, 0x36},
{0x3E, 0x41, 0x41, 0x41, 0x22},
{0x7F, 0x41, 0x41, 0x22, 0x1C},
{0x7F, 0x49, 0x49, 0x49, 0x41},
{0x7F, 0x09, 0x09, 0x09, 0x01},
{0x3E, 0x41, 0x49, 0x49, 0x7A},
{0x7F, 0x08, 0x08, 0x08, 0x7F},
{0x00, 0x41, 0x7F, 0x41, 0x00},
{0x20, 0x40, 0x41, 0x3F, 0x01},
{0x7F, 0x08, 0x14, 0x22, 0x41},
{0x7F, 0x40, 0x40, 0x40, 0x40},
{0x7F, 0x02, 0x0C, 0x02, 0x7F},
{0x7F, 0x04, 0x08, 0x10, 0x7F},
{0x3E, 0x41, 0x41, 0x41, 0x3E},
{0x7F, 0x09, 0x09, 0x09, 0x06},
{0x3E, 0x41, 0x51, 0x21, 0x5E},
{0x7F, 0x09, 0x19, 0x29, 0x46},
{0x46, 0x49, 0x49, 0x49, 0x31},
{0x01, 0x01, 0x7F, 0x01, 0x01},
{0x3F, 0x40, 0x40, 0x40, 0x3F},
{0x1F, 0x20, 0x40, 0x20, 0x1F},
{0x3F, 0x40, 0x38, 0x40, 0x3F},
{0x63, 0x14, 0x08, 0x14, 0x63},
{0x07, 0x08, 0x70, 0x08, 0x07},
{0x61, 0x51, 0x49, 0x45, 0x43},
{0x00, 0x7F, 0x41, 0x41, 0x00},
{0x02, 0x04, 0x08, 0x10, 0x20},
{0x00, 0x41, 0x41, 0x7F, 0x00},
{0x04, 0x02, 0x01, 0x02, 0x04},
{0x40, 0x40, 0x40, 0x40, 0x40},
{0x00, 0x01, 0x02, 0x04, 0x00},
{0x20, 0x54, 0x54, 0x54, 0x78},
{0x7F, 0x48, 0x44, 0x44, 0x38},
{0x38, 0x44, 0x44, 0x44, 0x20},
{0x38, 0x44, 0x44, 0x48, 0x7F},
{0x38, 0x54, 0x54, 0x54, 0x18},
{0x08, 0x7E, 0x09, 0x01, 0x02},
{0x0C, 0x52, 0x52, 0x52, 0x3E},
{0x7F, 0x08, 0x04, 0x04, 0x78},
{0x00, 0x44, 0x7D, 0x40, 0x00},
{0x20, 0x40, 0x44, 0x3D, 0x00},
{0x7F, 0x10, 0x28, 0x44, 0x00},
{0x00, 0x41, 0x7F, 0x40, 0x00},
{0x7C, 0x04, 0x18, 0x04, 0x78},
{0x7C, 0x08, 0x04, 0x04, 0x78},
{0x38, 0x44, 0x44, 0x44, 0x38},
{0x7C, 0x14, 0x14, 0x14, 0x08},
{0x08, 0x14, 0x14, 0x18, 0x7C},
{0x7C, 0x08, 0x04, 0x04, 0x08},
{0x48, 0x54, 0x54, 0x54, 0x20},
{0x04, 0x3F, 0x44, 0x40, 0x20},
{0x3C, 0x40, 0x40, 0x20, 0x7C},
{0x1C, 0x20, 0x40, 0x20, 0x1C},
{0x3C, 0x40, 0x30, 0x40, 0x3C},
{0x44, 0x28, 0x10, 0x28, 0x44},
{0x0C, 0x50, 0x50, 0x50, 0x3C},
{0x44, 0x64, 0x54, 0x4C, 0x44},
{0x00, 0x08, 0x36, 0x41, 0x00},
{0x00, 0x00, 0x7F, 0x00, 0x00},
{0x00, 0x41, 0x36, 0x08, 0x00},
{0x10, 0x08, 0x08, 0x10, 0x08},
{0x78, 0x46, 0x41, 0x46, 0x78},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x00, 0x00, 0x00, 0x00, 0x00},
{0x00, 0x00, 0x5F, 0x00, 0x00},
{0x00, 0x07, 0x00, 0x07, 0x00},
{0x14, 0x7F, 0x14, 0x7F, 0x14},
{0x24, 0x2A, 0x7F, 0x2A, 0x12},
{0x23, 0x13, 0x08, 0x64, 0x62},
{0x36, 0x49, 0x55, 0x22, 0x50},
{0x00, 0x05, 0x03, 0x00, 0x00},
{0x00, 0x1C, 0x22, 0x41, 0x00},
{0x00, 0x41, 0x22, 0x1C, 0x00},
{0x14, 0x08, 0x3E, 0x08, 0x14},
{0x08, 0x08, 0x3E, 0x08, 0x08},
{0x00, 0x50, 0x30, 0x00, 0x00},
{0x08, 0x08, 0x08, 0x08, 0x08},
{0x00, 0x60, 0x60, 0x00, 0x00},
{0x20, 0x10, 0x08, 0x04, 0x02},
{0x3E, 0x51, 0x49, 0x45, 0x3E},
{0x00, 0x42, 0x7F, 0x40, 0x00},
{0x42, 0x61, 0x51, 0x49, 0x46},
{0x21, 0x41, 0x45, 0x4B, 0x31},
{0x18, 0x14, 0x12, 0x7F, 0x10},
{0x27, 0x45, 0x45, 0x45, 0x39},
{0x3C, 0x4A, 0x49, 0x49, 0x30},
{0x01, 0x71, 0x09, 0x05, 0x03},
{0x36, 0x49, 0x49, 0x49, 0x36},
{0x06, 0x49, 0x49, 0x29, 0x1E},
{0x00, 0x36, 0x36, 0x00, 0x00},
{0x00, 0x56, 0x36, 0x00, 0x00},
{0x08, 0x14, 0x22, 0x41, 0x00},
{0x14, 0x14, 0x14, 0x14, 0x14},
{0x00, 0x41, 0x22, 0x14, 0x08},
{0x02, 0x01, 0x51, 0x09, 0x06},
{0x7E, 0x11, 0x11, 0x11, 0x7E},
{0x7F, 0x49, 0x49, 0x49, 0x31},
{0x7F, 0x49, 0x49, 0x49, 0x36},
{0x7F, 0x01, 0x01, 0x01, 0x03},
{0x70, 0x29, 0x27, 0x21, 0x7F},
{0x7F, 0x49, 0x49, 0x49, 0x41},
{0x77, 0x08, 0x7F, 0x08, 0x77},
{0x41, 0x41, 0x41, 0x49, 0x76},
{0x7F, 0x10, 0x08, 0x04, 0x7F},
{0x7F, 0x10, 0x09, 0x04, 0x7F},
{0x7F, 0x08, 0x14, 0x22, 0x41},
{0x20, 0x41, 0x3F, 0x01, 0x7F},
{0x7F, 0x02, 0x0C, 0x02, 0x7F},
{0x7F, 0x08, 0x08, 0x08, 0x7F},
{0x3E, 0x41, 0x41, 0x41, 0x3E},
{0x7F, 0x01, 0x01, 0x01, 0x7F},
{0x7F, 0x09, 0x09, 0x09, 0x06},
{0x3E, 0x41, 0x41, 0x41, 0x22},
{0x01, 0x01, 0x7F, 0x01, 0x01},
{0x47, 0x28, 0x10, 0x08, 0x07},
{0x1E, 0x21, 0x7F, 0x21, 0x1E},
{0x63, 0x14, 0x08, 0x14, 0x63},
{0x3F, 0x20, 0x20, 0x20, 0x5F},
{0x07, 0x08, 0x08, 0x08, 0x7F},
{0x7F, 0x40, 0x7F, 0x40, 0x7F},
{0x3F, 0x20, 0x3F, 0x20, 0x5F},
{0x01, 0x7F, 0x48, 0x48, 0x30},
{0x7F, 0x48, 0x30, 0x00, 0x7F},
{0x00, 0x7F, 0x48, 0x48, 0x30},
{0x41, 0x41, 0x41, 0x49, 0x3E},
{0x7F, 0x08, 0x3E, 0x41, 0x3E},
{0x46, 0x29, 0x19, 0x09, 0x7F},
{0x20, 0x54, 0x54, 0x54, 0x78},
{0x3C, 0x4A, 0x4A, 0x49, 0x31},
{0x7C, 0x54, 0x54, 0x28, 0x00},
{0x7C, 0x04, 0x04, 0x04, 0x0C},
{0x72, 0x2A, 0x26, 0x22, 0x7E},
{0x38, 0x54, 0x54, 0x54, 0x18},
{0x6C, 0x10, 0x7C, 0x10, 0x6C},
{0x44, 0x44, 0x54, 0x54, 0x38},
{0x7C, 0x20, 0x10, 0x08, 0x7C},
{0x7C, 0x21, 0x12, 0x09, 0x7C},
{0x7C, 0x10, 0x28, 0x44, 0x00},
{0x20, 0x44, 0x3C, 0x04, 0x7C},
{0x7C, 0x08, 0x10, 0x08, 0x7C},
{0x7C, 0x10, 0x10, 0x10, 0x7C},
{0x38, 0x44, 0x44, 0x44, 0x38},
{0x7C, 0x04, 0x04, 0x04, 0x7C},
{0x7C, 0x14, 0x14, 0x14, 0x08},
{0x38, 0x44, 0x44, 0x44, 0x20},
{0x04, 0x04, 0x7C, 0x04, 0x04},
{0x44, 0x28, 0x10, 0x08, 0x04},
{0x08, 0x14, 0x7E, 0x14, 0x08},
{0x44, 0x28, 0x10, 0x28, 0x44},
{0x3C, 0x40, 0x40, 0x7C, 0x40},
{0x0C, 0x10, 0x10, 0x10, 0x7C},
{0x7C, 0x40, 0x7C, 0x40, 0x7C},
{0x3C, 0x20, 0x3C, 0x20, 0x7C},
{0x04, 0x7C, 0x50, 0x50, 0x20},
{0x7C, 0x50, 0x20, 0x00, 0x7C},
{0x00, 0x7C, 0x50, 0x50, 0x20},
{0x28, 0x44, 0x44, 0x54, 0x38},
{0x7C, 0x10, 0x38, 0x44, 0x38},
{0x48, 0x54, 0x34, 0x14, 0x7C} 
} ;

static const char number[13][3][16]= {

{{0,128,192,224,224,96,224,224,192,128,0,0,0,0,0,0},
{112,255,255,1,0,0,0,0,255,255,254,0,0,0,0,0},
{0,15,31,60,56,48,56,56,31,15,3,0,0,0,0,0}},

{{0,0,0,0,128,224,224,0,0,0,0,0,0,0,0,0},
{0,0,3,3,3,255,255,0,0,0,0,0,0,0,0,0},
{0,0,56,56,56,63,63,56,56,56,0,0,0,0,0,0}},

{{0,192,192,224,96,96,224,224,192,128,0,0,0,0,0,0},
{0,1,0,0,128,192,224,249,63,31,0,0,0,0,0,0},
{0,60,62,63,63,59,57,56,56,56,56,0,0,0,0,0}},

{{0,192,224,224,96,96,224,224,192,192,0,0,0,0,0,0},
{0,1,0,0,48,48,56,125,239,207,0,0,0,0,0,0},
{0,28,56,56,48,48,56,60,31,15,1,0,0,0,0,0}},

{{0,0,0,0,0,128,192,224,224,0,0,0,0,0,0,0},
{224,240,248,222,207,199,193,255,255,192,192,0,0,0,0,0},
{0,0,0,0,0,0,0,63,63,0,0,0,0,0,0,0}},

{{0,224,224,224,224,224,224,224,224,224,224,0,0,0,0,0},
{0,63,63,63,56,56,48,112,240,224,0,0,0,0,0,0},
{0,28,56,56,48,48,56,60,31,15,3,0,0,0,0,0}},

{{0,0,128,192,192,224,96,96,224,224,0,0,0,0,0,0},
{224,254,255,55,57,24,24,56,240,240,192,0,0,0,0,0},
{0,15,31,28,56,48,48,56,31,15,7,0,0,0,0,0}},

{{0,224,224,224,224,224,224,224,224,224,224,0,0,0,0,0},
{0,0,0,0,128,224,248,126,31,7,1,0,0,0,0,0},
{0,0,56,62,31,7,1,0,0,0,0,0,0,0,0,0}},

{{0,128,192,224,224,96,96,224,192,192,0,0,0,0,0,0},
{0,207,255,127,56,48,112,112,255,239,199,0,0,0,0,0},
{3,15,31,60,56,48,48,56,31,31,15,0,0,0,0,0}},

{{0,128,192,224,224,96,224,224,192,128,0,0,0,0,0,0},
{12,63,127,241,224,192,192,225,255,255,254,0,0,0,0,0},
{0,0,56,48,48,56,56,30,15,7,0,0,0,0,0,0}},

{{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{60,60,60,0,0,0,0,0,0,0,0,0,0,0,0,0}},

{{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,64,64,64,64,64,254,254,64,64,64,64,64,0,0},
{0,0,0,0,0,0,0,15,15,0,0,0,0,0,0,0}},

{{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0},
{0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0}}
}; 

#pragma used-

#pragma library 3310.lib

#asm
   .equ __i2c_port=0x15 ;PORTC
   .equ __sda_bit=0
   .equ __scl_bit=1
#endasm

#pragma used+
void i2c_init(void);
unsigned char i2c_start(void);
void i2c_stop(void);
unsigned char i2c_read(unsigned char ack);
unsigned char i2c_write(unsigned char data);
#pragma used-

typedef unsigned char u8_t;
typedef unsigned int u16_t;
typedef unsigned long int u32_t;

void main(void)
{

DDRB=0xFF; 

ACSR=0x80;

i2c_init();

Nokia_initlcd();

Nokia_cursorxy(20,0);
Nokia_putstrf("");
Nokia_cursorxy(30,1);
Nokia_putstrf("");
Nokia_cursorxy(20,2);
Nokia_putstrf("Alcatel 311");
Nokia_cursorxy(0,3);
Nokia_putstrf(" ");
Nokia_cursorxy(0,4);
Nokia_putstrf(" ");
Nokia_cursorxy(0,5);
Nokia_putstrf("NOKIA 3310");
Nokia_cursorxy(0,6);
Nokia_putstrf("!!!");
Nokia_cursorxy(0,7);
Nokia_putstrf(".  ");

}
